
_InitMain:

;pic12f1840_MCP4921.c,4 :: 		void InitMain() {
;pic12f1840_MCP4921.c,6 :: 		ANSELA = 0x00;
	CLRF       ANSELA+0
;pic12f1840_MCP4921.c,7 :: 		CM1CON0 = 0x07;
	MOVLW      7
	MOVWF      CM1CON0+0
;pic12f1840_MCP4921.c,8 :: 		TRISA0_bit = 0;            // Set RA0 pin as output
	BCF        TRISA0_bit+0, BitPos(TRISA0_bit+0)
;pic12f1840_MCP4921.c,9 :: 		Chip_Select = 1;           // Deselect DAC
	BSF        RA4_bit+0, BitPos(RA4_bit+0)
;pic12f1840_MCP4921.c,10 :: 		Chip_Select_Direction = 0; // Set CS# pin as Output
	BCF        TRISA4_bit+0, BitPos(TRISA4_bit+0)
;pic12f1840_MCP4921.c,11 :: 		SPI1_Init();               // Initialize SPI module
	CALL       _SPI1_Init+0
;pic12f1840_MCP4921.c,13 :: 		return;
;pic12f1840_MCP4921.c,14 :: 		}//InitMain
L_end_InitMain:
	RETURN
; end of _InitMain

_DAC_Output:

;pic12f1840_MCP4921.c,16 :: 		void DAC_Output(unsigned int valueDAC) {
;pic12f1840_MCP4921.c,19 :: 		sL = valueDAC;               // Store valueDAC[7..0] to sL[7..0]
	MOVF       FARG_DAC_Output_valueDAC+0, 0
	MOVWF      DAC_Output_sL_L0+0
;pic12f1840_MCP4921.c,20 :: 		sH = (valueDAC >> 8) & 0x0F; // Store valueDAC[11..8] to sH[3..0]
	MOVF       FARG_DAC_Output_valueDAC+1, 0
	MOVWF      R0
	CLRF       R1
	MOVLW      15
	ANDWF      R0, 0
	MOVWF      FARG_SPI1_Write_data_+0
;pic12f1840_MCP4921.c,21 :: 		sH |= 0x30;                  // Add 1s to sH[5..4]; DAC setting, see MCP4921 datasheet
	MOVLW      48
	IORWF       FARG_SPI1_Write_data_+0, 1
;pic12f1840_MCP4921.c,23 :: 		Chip_Select = 0;             // Select DAC chip
	BCF        RA4_bit+0, BitPos(RA4_bit+0)
;pic12f1840_MCP4921.c,24 :: 		SPI1_Write(sH);              // Send high byte via SPI
	CALL       _SPI1_Write+0
;pic12f1840_MCP4921.c,25 :: 		SPI1_Write(sL);              // Send low byte via SPI
	MOVF       DAC_Output_sL_L0+0, 0
	MOVWF      FARG_SPI1_Write_data_+0
	CALL       _SPI1_Write+0
;pic12f1840_MCP4921.c,26 :: 		Chip_Select = 1;             // Deselect DAC chip
	BSF        RA4_bit+0, BitPos(RA4_bit+0)
;pic12f1840_MCP4921.c,28 :: 		return;
;pic12f1840_MCP4921.c,29 :: 		}//DAC_Output
L_end_DAC_Output:
	RETURN
; end of _DAC_Output

_main:

;pic12f1840_MCP4921.c,32 :: 		void main() {
;pic12f1840_MCP4921.c,33 :: 		float angle = 0.;
	CLRF       main_angle_L0+0
	CLRF       main_angle_L0+1
	CLRF       main_angle_L0+2
	CLRF       main_angle_L0+3
	CLRF       main_value_L0+0
	CLRF       main_value_L0+1
;pic12f1840_MCP4921.c,36 :: 		InitMain();
	CALL       _InitMain+0
;pic12f1840_MCP4921.c,38 :: 		while (1) {
L_main0:
;pic12f1840_MCP4921.c,40 :: 		value = (int)(2047. * (1. + sin(angle * PI_180)));
	MOVF       main_angle_L0+0, 0
	MOVWF      R0
	MOVF       main_angle_L0+1, 0
	MOVWF      R1
	MOVF       main_angle_L0+2, 0
	MOVWF      R2
	MOVF       main_angle_L0+3, 0
	MOVWF      R3
	MOVLW      219
	MOVWF      R4
	MOVLW      15
	MOVWF      R5
	MOVLW      73
	MOVWF      R6
	MOVLW      128
	MOVWF      R7
	CALL       _Mul_32x32_FP+0
	MOVLW      0
	MOVWF      R4
	MOVLW      0
	MOVWF      R5
	MOVLW      52
	MOVWF      R6
	MOVLW      134
	MOVWF      R7
	CALL       _Div_32x32_FP+0
	MOVF       R0, 0
	MOVWF      FARG_sin_f+0
	MOVF       R1, 0
	MOVWF      FARG_sin_f+1
	MOVF       R2, 0
	MOVWF      FARG_sin_f+2
	MOVF       R3, 0
	MOVWF      FARG_sin_f+3
	CALL       _sin+0
	MOVLW      0
	MOVWF      R4
	MOVLW      0
	MOVWF      R5
	MOVLW      0
	MOVWF      R6
	MOVLW      127
	MOVWF      R7
	CALL       _Add_32x32_FP+0
	MOVLW      0
	MOVWF      R4
	MOVLW      224
	MOVWF      R5
	MOVLW      127
	MOVWF      R6
	MOVLW      137
	MOVWF      R7
	CALL       _Mul_32x32_FP+0
	CALL       _double2int+0
	MOVF       R0, 0
	MOVWF      main_value_L0+0
	MOVF       R1, 0
	MOVWF      main_value_L0+1
;pic12f1840_MCP4921.c,41 :: 		angle += 1.;
	MOVF       main_angle_L0+0, 0
	MOVWF      R0
	MOVF       main_angle_L0+1, 0
	MOVWF      R1
	MOVF       main_angle_L0+2, 0
	MOVWF      R2
	MOVF       main_angle_L0+3, 0
	MOVWF      R3
	MOVLW      0
	MOVWF      R4
	MOVLW      0
	MOVWF      R5
	MOVLW      0
	MOVWF      R6
	MOVLW      127
	MOVWF      R7
	CALL       _Add_32x32_FP+0
	MOVF       R0, 0
	MOVWF      main_angle_L0+0
	MOVF       R1, 0
	MOVWF      main_angle_L0+1
	MOVF       R2, 0
	MOVWF      main_angle_L0+2
	MOVF       R3, 0
	MOVWF      main_angle_L0+3
;pic12f1840_MCP4921.c,42 :: 		if (angle > 359.) angle = 0.;
	MOVF       main_angle_L0+0, 0
	MOVWF      R4
	MOVF       main_angle_L0+1, 0
	MOVWF      R5
	MOVF       main_angle_L0+2, 0
	MOVWF      R6
	MOVF       main_angle_L0+3, 0
	MOVWF      R7
	MOVLW      0
	MOVWF      R0
	MOVLW      128
	MOVWF      R1
	MOVLW      51
	MOVWF      R2
	MOVLW      135
	MOVWF      R3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0
	MOVF       R0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main2
	CLRF       main_angle_L0+0
	CLRF       main_angle_L0+1
	CLRF       main_angle_L0+2
	CLRF       main_angle_L0+3
L_main2:
;pic12f1840_MCP4921.c,43 :: 		DAC_Output(value);
	MOVF       main_value_L0+0, 0
	MOVWF      FARG_DAC_Output_valueDAC+0
	MOVF       main_value_L0+1, 0
	MOVWF      FARG_DAC_Output_valueDAC+1
	CALL       _DAC_Output+0
;pic12f1840_MCP4921.c,44 :: 		Delay_us(100);
	MOVLW      33
	MOVWF      R13
L_main3:
	DECFSZ     R13, 1
	GOTO       L_main3
;pic12f1840_MCP4921.c,45 :: 		}//while
	GOTO       L_main0
;pic12f1840_MCP4921.c,48 :: 		}//main
L_end_main:
	GOTO       $+0
; end of _main
