sbit Chip_Select at RA4_bit;
sbit Chip_Select_Direction at TRISA4_bit;

void InitMain() {

     ANSELA = 0x00;
     CM1CON0 = 0x07;
     TRISA0_bit = 0;            // Set RA0 pin as output
     Chip_Select = 1;           // Deselect DAC
     Chip_Select_Direction = 0; // Set CS# pin as Output
     SPI1_Init();               // Initialize SPI module

     return;
}//InitMain

void DAC_Output(unsigned int valueDAC) {
char sL, sH;

     sL = valueDAC;               // Store valueDAC[7..0] to sL[7..0]
     sH = (valueDAC >> 8) & 0x0F; // Store valueDAC[11..8] to sH[3..0]
     sH |= 0x30;                  // Add 1s to sH[5..4]; DAC setting, see MCP4921 datasheet

     Chip_Select = 0;             // Select DAC chip
     SPI1_Write(sH);              // Send high byte via SPI
     SPI1_Write(sL);              // Send low byte via SPI
     Chip_Select = 1;             // Deselect DAC chip

     return;
}//DAC_Output

#define PI_180 3.14159265359 / 180.
void main() {
float angle = 0.;
unsigned int value = 0;

     InitMain();

     while (1) {
           value = (int)(2047. * (1. + sin(angle * PI_180)));
           angle += 1.;
           if (angle > 359.) angle = 0.;
           DAC_Output(value);
           Delay_us(100);
     }//while

    return;
}//main
